import type Firebase from "firebase";
import { Task, TaskLog, TaskStatus, TaskAttempt, TaskRequest, TaskDefinition, TaskInvocation } from "@dotdev/taskify-shared";
export declare const useTasks: (options?: {
    limit?: number;
    status?: TaskStatus;
    taskTypes?: string[];
}) => {
    tasks: import("react-firebase-hooks/firestore/dist/firestore/types").Data<Task<any>, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
    nextPage: () => void;
    hasNextPage: boolean;
    prevPage: () => void;
    hasPrevPage: boolean;
};
export declare const useTask: <T extends TaskDefinition = TaskDefinition>(taskRef?: Firebase.firestore.DocumentReference<Firebase.firestore.DocumentData> | undefined) => {
    task: import("react-firebase-hooks/firestore/dist/firestore/types").Data<Task<T>, "id", "ref"> | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useTaskAttempts: (taskRef?: Firebase.firestore.DocumentReference<Firebase.firestore.DocumentData> | undefined) => {
    taskAttempts: import("react-firebase-hooks/firestore/dist/firestore/types").Data<TaskAttempt, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useTaskLogs: (taskAttemptRef?: Firebase.firestore.DocumentReference<Firebase.firestore.DocumentData> | undefined) => {
    taskLogs: import("react-firebase-hooks/firestore/dist/firestore/types").Data<TaskLog, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useRunTask: <T extends TaskDefinition>(taskDefinition: T) => (taskRequest: TaskRequest<T>, options?: {
    openModal?: boolean;
}) => Promise<{
    taskRef: Firebase.firestore.DocumentReference<Task<T>>;
    taskAttemptRef: Firebase.firestore.DocumentReference<TaskAttempt>;
    taskInvocationRef: Firebase.firestore.DocumentReference<TaskInvocation>;
}>;
export declare const useRetryTask: (taskRef?: Firebase.firestore.DocumentReference<Task<any>> | undefined) => () => Promise<{
    taskAttemptRef: Firebase.firestore.DocumentReference<TaskAttempt>;
    taskInvocationRef: Firebase.firestore.DocumentReference<TaskInvocation>;
} | undefined>;
export declare const useViewTask: () => (taskRef: Firebase.firestore.DocumentReference<Task<any>>) => void;
export declare const useViewTaskPath: () => (taskPath: string) => void;
